""" 
XML-Parsing-Example
Copyright (c): Sascha Wille, inf6201@fh-wedel.de

You may study, modify and distribute this source code
FOR NON-COMMERCIAL PURPOSES ONLY.
This copyright message has to remain unchanged.

Note that this document is provided 'as is',
WITHOUT WARRANTY of any kind either expressed or implied.

"""
import sys
import xml.dom.minidom as dom

class Xml:
    file = None

    def __init__(self, file):
        self.file = file

    """ converts on element into a string-representation """
    def __parse_entry_element(self, e):
        return e.firstChild.data

    """ parses the previos specifies files """
    def load_address_book(self):
        d = {}       
        tree = dom.parse(self.file)
        tree = tree.getElementsByTagName("entry")
        for elem in tree:
            # just parse entry-elements
            if elem.nodeName == "entry":
                name = firstname = mobile = phone = None
                # get child-nodes
                for subElem in elem.childNodes:
                    if subElem.nodeName == "name":
                        name = self.__parse_entry_element(subElem)
                    elif subElem.nodeName == "firstname":
                        firstname = self.__parse_entry_element(subElem)
                    elif subElem.nodeName == "phone":
                        phone = self.__parse_entry_element(subElem)
                        mobile = elem.attributes["mobile"].value == "yes"
                
                d.setdefault(phone,(name, firstname, mobile))
        return d
